use ::std::env;
use parsing::grammar::parse;
use parsing::nested_type::Type;

use ::anyhow::Result;

fn main() -> Result<()> {
    let a = Type {
        repr: "NestedType".into(),
        ..Default::default()
    };
    let b = Type {
        repr: "MainType".into(),
        subtypes: vec![a.clone().into(), a.clone().into()],
    };
    println!("this is my python type : {}", b.to_python());
    println!("this is my cpp type : {}", b.to_cpp());

    let nested_type = match env::args().nth(1) {
        Some(t) => t,
        None => "Dict[str, int]".into(),
    };
    println!(
        "I parse an awesome nested_type : {}",
        parse(nested_type.into())?.to_python()
    );

    Ok(())
}
